//KonturInnenAusrichten_307d.js
// 26.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Dieses Script ndert die Kontur-Ausrichtung der Rahmen 
//von "mittig" auf "innen" und passt die Position und die 
//Grsse der Objekte entsprechend an.

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung");
	exit();
}

curDoc = app.documents[0];

// den Bezugspunkt in der Mitte auswhlen
var trp = app.layoutWindows[0].transformReferencePoint;
if (trp != 1095656308) {
	app.layoutWindows[0].transformReferencePoint = 1095656308;
}

// die Auswahl prfen
var curSel = app.selection;
var nSel = curSel.length;

// wenn nichts ausgewhlt ist 
if (nSel == 0) {
	var groupList = new Array ();
	//  alle Rahmen erfassen
	var allGroups = curDoc.groups;
	for (var i=0; i<allGroups.length; i++) {
		if (allGroups[i].locked == true) {
			try {
				allGroups[i].locked == false;
				groupList.push(allGroups[i]);
			}
			catch (e) {
				alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
				reStore(trp);
				exit();
			}
		}
	}
	nLocks = groupList.length;
	var allFrames = curDoc.allPageItems;
	var nFrames = allFrames.length; 
	modAll(allFrames, nFrames);
	if (nLocks > 0) {
		for (var k=0; k<nLocks; k++) {
			try {
				groupList[k].locked = true;
			}
			catch (e) {
				alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
				reStore(trp);
				exit();
			}
		}
	}
}

// sonst nur jene der Auswahl
else {
	modSel(curSel, nSel);
}

// den Handler zum Zurcksetzen des Bezugpunktes aufrufen
reStore(trp);

if (nSel == 0) {
	alert ("Fertig.");
}

function modAll(allFrames, nFrames) {
	var unLock;
	// die Sperrung der Ebenen speichern und aufheben (falls notwendig)
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	var layerLocks = new Array ();
	for (var i=0; i<nLayers; i++) {
		if (allLayers[i].locked == true) {
			allLayers[i].locked = false;
			layerLocks.push(true);
		}
		else {
			layerLocks.push(false);
		}		
	}
	for (var i=0; i<nFrames; i++) {
		// den aktuellen Rahmen der Variablen 'curFrame' zuweisen
		var curFrame = allFrames[i];
		// den Typ des Rahmens speichern
		var frameType = curFrame.constructor.name;
		// die Variable 'allFrames' enthlt eventuelle Gruppierungen 
		// als Elemente, aber deren Objekte kommen nochmals einzeln 
		// in der Liste vor. Deshalb: Gruppierungen ausschliessen, 
		// damit eine Fehlermeldung vermieden werden kann, wenn innerhalb 
		// einer Gruppe unterschiedliche Konturstrken vorkommen
		if (nLocks == 0) {
			if (frameType != "Group") {
				unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
						reStore(trp);
						exit();
					}
				}
				modFrame(curFrame);
				if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
		else {
			if (frameType == "Group") {
				var unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
						reStore(trp);
						exit();
					}
				}
			}
			if (frameType != "Group") {
				var unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
						reStore(trp);
						exit();
					}
				}
				modFrame(curFrame);
				if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
	}
	// die Sperrung der Ebenen wiederherstellen (falls notwendig)
	for (var i=0; i<nLayers; i++) {
		allLayers[i].locked = layerLocks[i];
	}
}

function modSel(curSel, nSel) {
	var actType;
	var actFrame;
	var curFrame;
	var curType;
	var topGroup;
	var unLock;
	var unLockParent;
	for (var i=0; i<nSel; i++) {
		// den aktuellen Rahmen der Variablen 'curFrame' zuweisen
		curFrame = curSel[i];
		// den Typ des Rahmens speichern
		curType = curFrame.constructor.name;
		// Elemente, welche keine Gruppierungen sind, der Funktion 
		// 'modFrame' bergeben, sonst nach 'modGroup' weiterleiten
		if (curType != "Group") {
			// den Rahmen feststellen, falls dieser nicht direkt 
			// ausgewhlt ist (= anwenderfreundlich :-)
			if (curType == "InsertionPoint" || curType == "Character" || curType == "Text" 
				|| curType == "Word" || curType == "Line" || curType == "Paragraph" 
				|| curType == "TextStyleRange" || curType == "TextColumn") {
				curFrame = curFrame.parentTextFrames[0];
			}
			// die Linienrahmen ausschliessen
			if (curType != "GraphicLine") {
				unLock = false;
				unLockParent = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						unLockParent = true;
						actType = "Group";
						actFrame = curFrame.parent;
						while (actType == "Group") {
							actType = actFrame.constructor.name;
							if (actType == "Group") {
								topGroup = actFrame;
							}
							try {
								actFrame.parent.locked = false;
							}
							catch (e) {
							}
							actFrame = actFrame.parent;
						}
					}
				}
				modFrame(curFrame);
				if (unLockParent == true) {
					try {
						topGroup.locked = true;
					}
					catch (e) {
					}
				}
				else if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
		else {
			unLock = false;
			if (curFrame.locked == true) {
				unLock = true;
				try {
					curFrame.locked = false;
				}
				catch (e) {
					alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
					reStore(trp);
					exit();
				}
			}
			modGroup(curFrame);
			if (unLock == true) {
				try {
					curFrame.locked = true;
				}
				catch (e) {
				}
			}
		}
	}
}

function modGroup(curGroup) {
	var allFrames = curGroup.allPageItems;
	var nFrames = allFrames.length; 
	var unLock;
	for (var i=0; i<nFrames; i++) {
		curFrame = allFrames[i];
		curType = curFrame.constructor.name;
		if (curType != "Group") {
			if (curType != "GraphicLine") {
				unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
						reStore(trp);
						exit();
					}
				}
				modFrame(curFrame);
				if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
	}
}

function modFrame(curFrame) {
	// nur Rahmen, deren Konturstrke zentriert ist, behandeln
	if (curFrame.strokeAlignment == StrokeAlignment.centerAlignment) {
		try {
			// Dreh- und/oder Neigungswinkel auf Null setzen (falls notwendig)
			var curRot = curFrame.rotationAngle;
			if (curRot != 0) {
				curFrame.rotationAngle = 0;
			}
			var curShear = curFrame.shearAngle;
			if (curShear != 0) {
				curFrame.shearAngle = 0;
			}
			// die neuen Werte der "bounds" zuweisen
			curFrame.geometricBounds = curFrame.visibleBounds;
			// Kontur nach innen ausrichten 
			curFrame.strokeAlignment = StrokeAlignment.insideAlignment;
			// Dreh- und/oder Neigungswinkel zurcksetzen
			if (curRot != 0) {
				curFrame.rotationAngle = curRot;
			}
			if (curShear != 0) {
				curFrame.shearAngle = curShear;
			}
		}
		catch (e) {
			alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
			reStore(trp);
			exit();
		}
	}
}

// den Bezugspunkt zurcksetzen (falls notwendig)
function reStore(trp) {
	if (trp != 1095656308) {
		app.layoutWindows[0].transformReferencePoint = trp;
	}
}